package jp.agentec.sinaburocast.form.admin.enquete;

import jp.agentec.sinaburocast.common.util.SinaburoUtil;
import jp.agentec.sinaburocast.common.util.SinaburoViewUtil;

import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.seasar.framework.util.StringUtil;
import org.seasar.struts.annotation.Arg;
import org.seasar.struts.annotation.Msg;
import org.seasar.struts.annotation.Required;




/**
 * アンケートメール設定Form
 *
 * @author choi-c
 *
 */
public class EnqueteMailSettingForm {
	
	
	
	/**
	 * アンケートID	
	 */
	public String eid;
	
	/**
	 * アンケート名	
	 */
	public String enqueteName;
	
	
	public String adminEnqueteId;
	
	@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailSend"))
	public String adminNotifyMailSendFlg;
	
	//カンマ区切り
	//@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailSendTo"))
	public String adminNotifyMailSendTo;
	//カンマ区切り
	public String adminNotifyMailSendCc;
	
	//@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.subject"))
	public String adminSubject;
	
	//@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailBody"))
	public String adminMailBody;

	public String memberEnqueteId;
	//@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailSend"))
	public String memberNotifyMailSendFlg;
	
	//カンマ区切り
	public String memberNotifyMailSendBcc;
	
	//@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.subject"))
	public String memberSubject;
	
	//@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailBody"))
	public String memberMailBody;
	
	public ActionMessages validate(){
		ActionMessages errors = new ActionMessages();
		
		if (StringUtil.equals(adminNotifyMailSendFlg, "1")) {
			// 必須チェック
			if (StringUtil.isBlank(adminNotifyMailSendTo)) {
				errors.add("adminNotifyMailSendTo", new ActionMessage("errors.required",SinaburoViewUtil.getMessage("labels.mailSendTo")));
			}

			if (StringUtil.isBlank(adminSubject)) {
				errors.add("adminSubject", new ActionMessage("errors.required",SinaburoViewUtil.getMessage("labels.subject")));
			}

			if (StringUtil.isBlank(adminMailBody)) {
				errors.add("adminMailBody", new ActionMessage("errors.required",SinaburoViewUtil.getMessage("labels.mailBody")));
			}
		}
		
		if (StringUtil.equals(memberNotifyMailSendFlg, "1")) {
			//メンバー
			if(StringUtil.isBlank(memberSubject)){
				errors.add("memberSubject", new ActionMessage("errors.required",SinaburoViewUtil.getMessage("labels.subject")));
			}
			
			if(StringUtil.isBlank(memberMailBody)){
				errors.add("memberMailBody", new ActionMessage("errors.required",SinaburoViewUtil.getMessage("labels.mailBody")));
			}
		}
		
		
		String [] split=null;
		
		if(StringUtil.isNotBlank(adminNotifyMailSendTo)){
			split =adminNotifyMailSendTo.trim().split(",");
			for (String email : split) {
				if(!SinaburoUtil.emailCheck(email)){
					errors.add("adminNotifyMailSendTo", new ActionMessage("errors.email",adminNotifyMailSendTo));
					break;
				}
			}
		}
		
		if(StringUtil.isNotBlank(adminNotifyMailSendCc)){
			split =adminNotifyMailSendCc.trim().split(",");
			for (String email : split) {
				if(!SinaburoUtil.emailCheck(email)){
					errors.add("adminNotifyMailSendCc", new ActionMessage("errors.email",email));
					break;
				}
			}
		}
		
//		if(StringUtil.isNotBlank(memberNotifyMailSendBcc)){
//			split =memberNotifyMailSendBcc.trim().split(",");
//			for (String email : split) {
//				if(!SinaburoUtil.emailCheck(email)){
//					errors.add("memberNotifyMailSendBcc", new ActionMessage("errors.email",email));
//					break;
//				}
//			}
//		}
		
		if(StringUtil.isNotBlank(memberNotifyMailSendBcc)){
			if(!SinaburoUtil.emailCheck(memberNotifyMailSendBcc)){
				errors.add("memberNotifyMailSendBcc", new ActionMessage("errors.email",memberNotifyMailSendBcc));
			}
		}
		
		return errors;
	}
	
}
