package jp.agentec.sinaburocast.service;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;

import jp.agentec.sinaburocast.entity.DeliveryGroupMember;
import jp.agentec.sinaburocast.entity.EnqueteMailAddressTmp;
import jp.agentec.sinaburocast.entity.Member;
import junit.framework.TestSuite;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.seasar.dao.unit.S2DaoTestCase;

public class EnqueteMailAddressTmpServiceTest extends S2DaoTestCase {

	@Resource
	private EnqueteMailAddressTmpService enqueteMailAddressTmpService;

	public EnqueteMailAddressTmpServiceTest(String string) {
		super(string);
	}

	public static TestSuite suite() {
		TestSuite suite = new TestSuite("EnqueteMailSendResultServiceTest");
		// suite.addTest(new EnqueteMailAddressTmpServiceTest("insert"));
		// suite.addTest(new
		// EnqueteMailAddressTmpServiceTest("findByEnqueteMailId"));
		// suite.addTest(new
		// EnqueteMailAddressTmpServiceTest("deleteByEnqueteMailId"));
		suite.addTest(new EnqueteMailAddressTmpServiceTest("deleteInsert"));
		return suite;
	}

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		include("app.dicon");
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	public void insert() {
		EnqueteMailAddressTmp address1 = new EnqueteMailAddressTmp();
		address1.enqueteMailId = 2;
		address1.email = "address1";

		EnqueteMailAddressTmp address2 = new EnqueteMailAddressTmp();
		address2.enqueteMailId = 3;
		address2.email = "address2";

		enqueteMailAddressTmpService.insert(address1, "SYSTEM");
		enqueteMailAddressTmpService.insert(address2, "SYSTEM");
	}

	public void findByEnqueteMailId() {
		for (EnqueteMailAddressTmp address : enqueteMailAddressTmpService.findByEnqueteMailId(2)) {
			System.out.println(address.email);
		}
	}

	public void deleteByEnqueteMailId() {
		enqueteMailAddressTmpService.deleteByEnqueteMailId(2);
	}

	public void deleteInsert() {
		List<DeliveryGroupMember> addressList = new ArrayList<DeliveryGroupMember>();
		DeliveryGroupMember deliveryGroupMember = new DeliveryGroupMember();
		deliveryGroupMember.member = new Member();
		deliveryGroupMember.member.pcEmail = "tauchi@agentec.jp";
		addressList.add(deliveryGroupMember);
		enqueteMailAddressTmpService.deleteInsert(2, addressList, "test");
	}
}
